VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} GwxLoadRecipe_MainForm 
   Caption         =   "Recipe Selection Screen"
   ClientHeight    =   5685
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7245
   OleObjectBlob   =   "GwxLoadRecipe_MainForm.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "GwxLoadRecipe_MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public WBObj As Excel.Workbook
Public ExcelObj As Excel.Application
Const RECIPE_START_ROW = 5
Const RECIPE_END_ROW = 16
Const RECIPE_NAME_COL = 1

Private Sub cmdCancel_Click()
  ExcelObj.Quit
  DoEvents
  Set WBObj = Nothing 'close down the invisible excel app.
  Set ExcelObj = Nothing 'close down the invisible excel app.
  DoEvents
  Unload Me
  End
End Sub

Private Sub cmdUse_Click()
 Dim ret%
 Dim batchID As String
 Dim opcpoint As GwxPoint
 Dim setAliasString As String
 Dim RecipeSelected As String
 Dim comment As String
 Dim severity As Integer
 Dim parameter As String
 
 comment = "Operator selected a new Recipe"
 severity = 700 'OPC Alarm&Event Severity ranges from 0 to 999.
 parameter = "Recipe Loaded"
   
   ExcelObj.Quit
   DoEvents
   Set WBObj = Nothing 'close down the invisible excel app.
   Set ExcelObj = Nothing 'close down the invisible excel app.
   DoEvents
     RecipeSelected = lstRecipes.List(lstRecipes.ListIndex) 'store which recipe was selected
     PostEvent "Recipe Changed", "New Recipe downloaded:  " + RecipeSelected, comment, severity, parameter
      'set up the aliases for this recipe
      batchID = Format(Now, "mmddyy.hhnnss")
      PostEvent "Batch Started", "New Batch Started:  " + batchID, comment, severity, parameter
      setAliasString = "batchID" + vbTab + batchID + vbCrLf + "recipe" + vbTab + "$""" + RecipeSelected + """$"
      ret = ThisDisplay.SetAliases(setAliasString)
      'now download the values in this recipe to the OPC Tags
      Set opcpoint = ThisDisplay.GetPointObjectFromName("ICONICS.Simulator.1\SimulatePLC.OUTPUTS.FLOAT")
      opcpoint.Value = txtTemp
      Set opcpoint = ThisDisplay.GetPointObjectFromName("ICONICS.Simulator.1\SimulatePLC.OUTPUTS.FLOAT1")
      opcpoint.Value = txtA
      Set opcpoint = ThisDisplay.GetPointObjectFromName("ICONICS.Simulator.1\SimulatePLC.OUTPUTS.FLOAT2")
      opcpoint.Value = txtB
      Set opcpoint = ThisDisplay.GetPointObjectFromName("ICONICS.Simulator.1\SimulatePLC.OUTPUTS.FLOAT3")
      opcpoint.Value = txtC
      Set opcpoint = ThisDisplay.GetPointObjectFromName("ICONICS.Simulator.1\SimulatePLC.OUTPUTS.FLOAT4")
      opcpoint.Value = txtD
   Me.Hide ' this returns control back to calling routine
End Sub



Private Sub lstRecipes_Click()
On Error GoTo TrapError
  Dim index As Integer
  index = lstRecipes.ListIndex + RECIPE_START_ROW
  txtTemp = WBObj.Sheets(1).Cells(index, 2)
  txtA = WBObj.Sheets(1).Cells(index, 3)
  txtB = WBObj.Sheets(1).Cells(index, 4)
  txtC = WBObj.Sheets(1).Cells(index, 5)
  txtD = WBObj.Sheets(1).Cells(index, 6)
  txtValvePos = WBObj.Sheets(1).Cells(index, 7)
  txtLimit = WBObj.Sheets(1).Cells(index, 8)
  Exit Sub
  
TrapError:
If Err = 91 Then
  MsgBox "The link to Excel has been modified... cannot access at this time."
 Else
   MsgBox "This demo script has encountered a problem:" + vbCrLf + str(Err) + ": " + Error(Err), vbCritical, "Recipe VBA Example Error"
 Exit Sub
End If
  
End Sub

Private Sub txtA_Change()

End Sub

Private Sub txtB_Change()

End Sub

Private Sub UserForm_Initialize()
  On Error GoTo INIT_ERR
  Dim row As Integer
  Dim EmptyRow As Integer
  Dim temp As String
  Dim RECIPE_FILE As String
  Dim ret As Integer
  
  'find out if someone is logged in first!
  If GetUserName() = "" Then
    ret = MsgBox("Insufficient Security to load a new recipe." + vbCrLf + "Do you wish to log in now?", vbYesNo + vbExclamation, "Security Restricted Access")
    If ret = vbYes Then
       'updated for version 8.0 to make use of the new LoginActiveX control
       Call LogInUser
       'Shell "login.exe", vbNormalFocus
    End If
    
    End 'EXIT THE PROGRAM RIGHT HERE!!!!!!!!!!
  
  End If
  
  lblUserName = "User: " + GetUserName() 'show who's logged in on the recipe form
  
  RECIPE_FILE = ThisDisplay.GetFilePath + "\PainReliefRECIPE.XLS" 'path to the recipe file
  EmptyRow = False
  Set ExcelObj = CreateObject("Excel.Application") 'this gets a handle on EXCEL
  Set WBObj = ExcelObj.Workbooks.Open(RECIPE_FILE) ' open up the spreadsheet (invisibly!)
  row = RECIPE_START_ROW
  While Not EmptyRow 'read until there are no more recipes in the spreadsheet
    temp = WBObj.Sheets(1).Cells(row, RECIPE_NAME_COL).Value
    If temp <> "" Then 'it has a recipe, so continue reading
     lstRecipes.AddItem temp 'add this recipe name to the list
     row = row + 1
   Else
      EmptyRow = True
    End If
  Wend
  
  'For row = RECIPE_START_ROW To RECIPE_END_ROW
    'lstRecipes.AddItem (WBObj.Sheets(1).Cells(row, RECIPE_NAME_COL).Value)
  'Next row
  lstRecipes.ListIndex = 0
  Exit Sub
  
'the following is error handling for this subroutine
INIT_ERR:
  If Err = 429 Then
    ret = MsgBox("Excel isn't running. This function cannot continue until it is started.  Launch EXCEL then press OK", vbExclamation + vbOKCancel, "EXCEL not running")
    If ret = 2 Then
      End
    Else
      Resume
    End If
  ElseIf Err = 1004 Then
    ret = MsgBox("The recipe file for Excel could not be found, or is currently being editted." + vbCr + vbCr + """" + RECIPE_FILE + """" + vbCr + vbCr + "This function cannot continue until this file is in this location.  Please correct, then press OK", vbExclamation + vbOKCancel, "Recipe File Not Found")
    If ret = 2 Then
      End
    Else
      Resume
    End If
  Else
    MsgBox "Script FormInit Error: " + str(Err) + "  " + Error(Err)
  End If

Exit Sub
Resume 'for debug purposes

End Sub
